C     Last change:  BCM  29 Sep 1997  9:27 am
**==gauss.f    processed by SPAG 4.03F  at 09:48 on  1 Mar 1994
      DOUBLE PRECISION FUNCTION gauss(X)
c-----------------------------------------------------------------------
c     This function calculates normal probability levels for
c pr(-x < N(0,1) r.v. < x ).
c
c     This function/subroutine was developed by Statistics Canada.
c     We thank them for permission to use it here.
c-----------------------------------------------------------------------
      IMPLICIT NONE
      DOUBLE PRECISION X,y,z,w
c     ------------------------------------------------------------------
      LOGICAL dpeq
      EXTERNAL dpeq
c     ------------------------------------------------------------------
      IF(.not.dpeq(X,0D0))THEN
       y=abs(X)/2.0D0
c     ------------------------------------------------------------------
       IF(y.ge.3.0D0)THEN
        gauss=1.0D0
        RETURN
c     ------------------------------------------------------------------
       ELSE IF(y.ge.1.0D0)THEN
        y=y-2.0D0
        z=(((((((((((((-0.000045255659D0*y+0.000152529290D0)*y-
     &    0.000019538132D0)*y-0.000676904986D0)*y+0.001390604284D0)
     &    *y-0.000794620820D0)*y-0.002034254874D0)*y+0.006549791214D0)
     &    *y-0.010557625006D0)*y+0.011630447319D0)*y-0.009279453341D0)
     &    *y+0.005353579108D0)*y-0.002141268741D0)*y+0.000535310849D0)
     &    *y+0.999936657524D0
c     ------------------------------------------------------------------
       ELSE
        w=y*y
        z=((((((((0.000124818987D0*w-0.001075204047D0)*w+
     &    0.005198775019D0)*w-0.019198292004D0)*w+0.059054035642D0)
     &    *w-0.151968751364D0)*w+0.319152932694D0)*w-0.531923007300D0)
     &    *w+0.797884560593D0)*y*2.0D0
       END IF
c     ------------------------------------------------------------------
      ELSE
       gauss=0.0D0
       RETURN
      END IF
c     ------------------------------------------------------------------
      gauss=z
c     ------------------------------------------------------------------
      RETURN
      END
