C     Last change:  BCM  30 Jul 2008 4:05 pm
      SUBROUTINE tdaic(Trnsrs,A,Nefobs,Na,Frstry,Lester,Tdmdl1,Ltdlom,
     &                 Lprtit,Ptrstp,Ptrfm,Ptrsvl,Lsumm,Lhiddn)
      IMPLICIT NONE
c-----------------------------------------------------------------------
c     Estimate two regARIMA models: one with TD, one without.  The
c     routine will choose the model with the lowest value of AICC and
c     print out the resulting model.
c-----------------------------------------------------------------------
      LOGICAL F,T
      INTEGER DIV,MULT,PLOM,PLOQ
      PARAMETER(DIV=4,MULT=3,PLOM=2,PLOQ=3,F=.false.,T=.true.)
c-----------------------------------------------------------------------
      INCLUDE 'srslen.prm'
      INCLUDE 'model.prm'
      INCLUDE 'model.cmn'
      INCLUDE 'mdldat.cmn'
      INCLUDE 'arima.cmn'
      INCLUDE 'inpt.cmn'
      INCLUDE 'lkhd.cmn'
      INCLUDE 'adj.cmn'
      INCLUDE 'prior.prm'
      INCLUDE 'prior.cmn'
      INCLUDE 'priadj.cmn'
      INCLUDE 'priusr.cmn'
      INCLUDE 'extend.cmn'
      INCLUDE 'notset.prm'
      INCLUDE 'units.cmn'
      INCLUDE 'error.cmn'
      INCLUDE 'title.cmn'
      INCLUDE 'tbllog.prm'
      INCLUDE 'tbllog.cmn'
      INCLUDE 'svllog.prm'
      INCLUDE 'svllog.cmn'
c-----------------------------------------------------------------------
      INTEGER PA
      DOUBLE PRECISION ONE
      PARAMETER(PA=PLEN+2*PORDER,ONE=1D0)
c-----------------------------------------------------------------------
      CHARACTER tdstr*(25),fmtsvl*(21)
      LOGICAL pktd,lprt,lhide,Lprtit,Lester,lom,argok,lsavlg,
     &        begrgm,Lhiddn,Ltdlom
      DOUBLE PRECISION A,a2,aic1,aic2,aicntd,aictd,lomeff,tap,tb,
     &                 Trnsrs,tsrs
      INTEGER Frstry,Tdmdl1,kf2,Na,Nefobs,begcol,ncol,ilom,lencol,
     &        irgfx,igrp,endlag,ilag,ntdchr,Ptrstp,Ptrfm,Lsumm,Ptrsvl,
     &        pptrfm
      DIMENSION A(PA),lomeff(PLEN),tap(PARIMA),tb(PB),Trnsrs(PLEN),
     &          tsrs(PLEN),a2(PLEN),begrgm(PLEN)
c-----------------------------------------------------------------------
      INTEGER strinx
      LOGICAL dpeq
      EXTERNAL dpeq,strinx
c-----------------------------------------------------------------------
      IF(Ptrstp.eq.0)THEN
       lprt=F
      ELSE
       lprt=Prttab(Ptrstp)
      END IF
      pptrfm=Ptrfm
      IF(Ptrstp.eq.0)pptrfm=0
      IF(Ptrsvl.eq.0)THEN
       lsavlg=F
      ELSE
       lsavlg=Svltab(Ptrsvl)
      END IF
c-----------------------------------------------------------------------
c     Store initial model values
c-----------------------------------------------------------------------
      CALL setdp(ONE,PLEN,lomeff)
      CALL copy(Adj,PLEN,1,a2)
      irgfx=Iregfx
      pktd=Picktd
c-----------------------------------------------------------------------
c     Make copy of transformed data
c-----------------------------------------------------------------------
      CALL copy(Trnsrs,PLEN,1,tsrs)
c-----------------------------------------------------------------------
c     Set indicator variable to determine if td regression is in the
c     regression variables.
c-----------------------------------------------------------------------
      Tdmdl1=strinx(T,Grpttl,Grpptr,1,Ngrptl,'Trading Day')
      IF(Tdmdl1.eq.0.and.Itdtst.eq.3)
     &   Tdmdl1=strinx(T,Grpttl,Grpptr,1,Ngrptl,'Stock Trading Day')
c-----------------------------------------------------------------------
c     Generate string for label of trading day effect
c-----------------------------------------------------------------------
      CALL mktdlb(tdstr,ntdchr,Itdtst,Aicstk,Aicrgm,Tdzero,Sp)
      IF(lsavlg)THEN
       CALL setchr(' ',21,fmtsvl)
       WRITE(fmtsvl,1011)MAX(ntdchr,4)+10
      END IF
c-----------------------------------------------------------------------
c     Check for length of month or leapyear regressors.
c-----------------------------------------------------------------------
      lencol=strinx(T,Colttl,Colptr,1,Ncoltl,'Length-of-')
      IF(lencol.eq.0)lencol=strinx(T,Colttl,Colptr,1,Ncoltl,
     &                             'Stock Length-of-')
      IF(lencol.eq.0)lencol=strinx(F,Colttl,Colptr,1,Ncoltl,'Leap Year')
c-----------------------------------------------------------------------
c     Generate length of month effect for possible later use.
c-----------------------------------------------------------------------
      IF(Priadj.eq.PLOM.or.Priadj.eq.PLOQ)THEN
       lom=T
      ELSE
       lom=F
      END IF
      IF(Lrgmtd.and.MOD(Tdzero,2).ne.0)THEN
       CALL gtrgpt(Begadj,Tddate,Tdzero,begrgm,Nadj)
      ELSE
       CALL setlg(T,PLEN,begrgm)
      END IF
      CALL td7var(Begadj,Sp,Nadj,1,1,lom,F,T,lomeff,begrgm)
c-----------------------------------------------------------------------
c     Estimate the model
c-----------------------------------------------------------------------
      argok=Lautom.or.Lautox
      CALL rgarma(T,Mxiter,Mxnlit,F,A,Na,Nefobs,argok)
c      CALL rgarma(T,Mxiter,Mxnlit,T,A,Na,Nefobs,argok)
      IF((.not.Lfatal).and.(Lautom.or.Lautox).and.(.not.argok))Lester=T
      IF(Lfatal)RETURN
c-----------------------------------------------------------------------
c     If an estimation error is found, discontinue the routine.
c-----------------------------------------------------------------------
      IF(Armaer.eq.PMXIER.or.Armaer.eq.PSNGER.or.Armaer.eq.PISNER.or.
     &   Armaer.eq.PNIFER.or.Armaer.eq.PNIMER.or.Armaer.eq.PCNTER.or.
     &   Armaer.lt.0.or.((Lautom.or.Lautox).and..not.argok))THEN
       Lester=T
       RETURN
c-----------------------------------------------------------------------
c     If only a warning message would be printed out, reset the error
c     indicator variable to zero.
c-----------------------------------------------------------------------
      ELSE IF(Armaer.ne.0)THEN
       Armaer=0
      END IF
c-----------------------------------------------------------------------
c     Copy the parameter estimates to temporary variables
c-----------------------------------------------------------------------
      CALL copy(Arimap,PARIMA,1,tap)
      CALL copy(B,PB,1,tb)
c-----------------------------------------------------------------------
c     Compute the likelihood statistics and AICC for the first model
c-----------------------------------------------------------------------
      IF(.not.lprt)THEN
       lhide=Lhiddn
       Lhiddn=T
      END IF
      IF(Tdmdl1.eq.0)THEN
       IF(lprt)THEN
        IF(Laccss)CALL insacd(Mt1,'regression.ats.hdr',T)
        WRITE(Mt1,1010)tdstr(1:ntdchr)
        IF(Laccss)CALL insacd(Mt1,'regression.ats.hdr',F)
       END IF
       CALL prlkhd(Y(Frstsy),Adj(Adj1st),Adjmod,Fcntyp,Lam,0,Ptrstp,0)
       IF(Lfatal)RETURN
       aicntd=Aicc
       IF(Lsavlg)THEN
        IF(Laccss)CALL insacd(Ng,'regression.ats.lkhd',T)
        WRITE(Ng,fmtsvl)'AICC(no td)',':',Aicc
       END IF
       IF(Lsumm.gt.0)WRITE(Nform,1013)'notd',Aicc
      ELSE
       IF(lprt)THEN
        IF(Laccss)CALL insacd(Mt1,'regression.ats.hdr',T)
        WRITE(Mt1,1020)tdstr(1:ntdchr)
        IF(Laccss)CALL insacd(Mt1,'regression.ats.hdr',F)
       END IF
       CALL prlkhd(Y(Frstsy),Adj(Adj1st),Adjmod,Fcntyp,Lam,0,Ptrstp,0)
       IF(Lfatal)RETURN
       aictd=Aicc
       IF(Lsavlg)THEN
        IF(Laccss)CALL insacd(Ng,'regression.ats.lkhd',T)
        WRITE(Ng,fmtsvl)'AICC('//tdstr(1:ntdchr)//')',':',Aicc
       END IF
       IF(Lsumm.gt.0)WRITE(Nform,1013)'td',Aicc
      END IF
      aic1=Aicc
c-----------------------------------------------------------------------
c     Restore initial values to model variables
c-----------------------------------------------------------------------
      CALL restor(T,F,F)
      CALL regvar(Trnsrs,Nobspf,Fctdrp,Nfcst,0,Userx,Bgusrx,Nrusrx,
     &            Priadj,Reglom,Nrxy,Begxy,Frstry,T,Elong)
      IF((.not.Lfatal).and.Iregfx.ge.2)THEN
       CALL rmfix(trnsrs,Nbcst,Nrxy,1)
       IF(.not.Lfatal)
     &    CALL regvar(trnsrs,Nobspf,Fctdrp,Nfcst,0,Userx,Bgusrx,Nrusrx,
     &                Priadj,Reglom,Nrxy,Begxy,frstry,T,Elong)
      END IF
c-----------------------------------------------------------------------
      IF(Lfatal)THEN
       IF(lsavlg.and.Laccss)CALL insend(Ng,'regression.ats.lkhd')
       RETURN
      END IF
c-----------------------------------------------------------------------
      IF(Nopr.gt.0)THEN
       endlag=Opr(Nopr)-1
       DO ilag=1,endlag
        IF(.not.Arimaf(ilag))Arimap(ilag)=DNOTST
       END DO
      END IF
c-----------------------------------------------------------------------
c     Keep track of whether length of month adjustment is done
c-----------------------------------------------------------------------
      ilom=Priadj
c-----------------------------------------------------------------------
c     If model 1 had no TD, add TD to regression variables
c-----------------------------------------------------------------------
      IF(Tdmdl1.eq.0)THEN
c-----------------------------------------------------------------------
c     If the td or td1coef options are selected, set Picktd to true and
c     add either a leap year regressor or leap year preadjustment
c     factors, depending on the data transformation.
c-----------------------------------------------------------------------
       IF(Itdtst.eq.1.or.Itdtst.eq.4)THEN
        Picktd=T
        IF(Fcntyp.eq.4.OR.dpeq(Lam,1D0))THEN
         IF(Ltdlom)THEN
          IF(Sp.eq.12)THEN
           CALL adrgef(DNOTST,'Length-of-Month','Length-of-Month',
     &                 PRGTLM,F,F)
          ELSE IF(Sp.eq.4)THEN
           CALL adrgef(DNOTST,'Length-of-Quarter','Length-of-Quarter',
     &                 PRGTLQ,F,F)
          END IF
         ELSE
          CALL adrgef(DNOTST,'Leap Year','Leap Year',PRGTLY,F,F)
         END IF
        ELSE
         IF(Ltdlom)THEN
          IF(Sp.eq.12)THEN
           Priadj=PLOM
          ELSE IF(Sp.eq.4)THEN
           Priadj=PLOQ
          END IF
         ELSE
          Priadj=4
         END IF
        END IF
       END IF
c-----------------------------------------------------------------------
       IF(Lfatal)THEN
        IF(lsavlg.and.Laccss)CALL insend(Ng,'regression.ats.lkhd')
        RETURN
       END IF
c-----------------------------------------------------------------------
       Iregfx=0
       CALL addaic(Aicstk,Aicrgm,Tdzero,0,Sp,Itdtst,F,Easidx)
c-----------------------------------------------------------------------
c     Length of Month adjust original series, if necessary.
c-----------------------------------------------------------------------
       kf2=Kfmt
       IF((ilom.le.1.and.Picktd).AND.(.not.(Fcntyp.eq.4.OR.
     &     dpeq(Lam,1D0))))THEN
c-----------------------------------------------------------------------
c     Generate length of month (or length of quarter) variables.
c-----------------------------------------------------------------------
        IF(kf2.eq.0)THEN
c         CALL addate(Begspn,Sp,-Nbcst,Begadj)
c         Nadj=Nspobs+Nbcst+max(Sp,Nfcst-Fctdrp)
         CALL eltfcn(DIV,Y(Frstsy),lomeff(Adj1st),Nobspf,PLEN,Trnsrs)
         IF(Lmvaft.or.Ln0aft)THEN
          CALL trnfcn(trnsrs,Nspobs,Fcntyp,Lam,trnsrs)
         ELSE
          CALL trnfcn(trnsrs,Nobspf,Fcntyp,Lam,trnsrs)
         END IF
         IF(.not.Lfatal)THEN
          CALL copy(lomeff,PLEN,1,Adj)
          Kfmt=1
         END IF
        ELSE
         CALL eltfcn(DIV,Y(Frstsy),lomeff(Adj1st),Nobspf,PLEN,Trnsrs)
         CALL eltfcn(DIV,Trnsrs,Adj(Adj1st),Nobspf,PLEN,Trnsrs)
         IF(Lmvaft.or.Ln0aft)THEN
          CALL trnfcn(trnsrs,Nspobs,Fcntyp,Lam,trnsrs)
         ELSE
          CALL trnfcn(trnsrs,Nobspf,Fcntyp,Lam,trnsrs)
         END IF
         IF(.not.Lfatal)
     &      CALL eltfcn(MULT,lomeff(Adj1st),Adj(Adj1st),Nobspf,PLEN,
     &                  Adj(Adj1st))
        END IF
       END IF
c-----------------------------------------------------------------------
       IF(Lfatal)THEN
        IF(lsavlg.and.Laccss)CALL insend(Ng,'regression.ats.lkhd')
        RETURN
       END IF
c-----------------------------------------------------------------------
c     Else, if model 1 had trading day, delete trading day variables
c-----------------------------------------------------------------------
      ELSE
       DO igrp=Ngrp,1,-1
        begcol=Grp(igrp-1)
        ncol=Grp(igrp)-begcol
        IF(Rgvrtp(begcol).eq.PRGTST.or.Rgvrtp(begcol).eq.PRGTTD.or.
     &     Rgvrtp(begcol).eq.PRRTST.or.Rgvrtp(begcol).eq.PRRTTD.or.
     &     Rgvrtp(begcol).eq.PRATST.or.Rgvrtp(begcol).eq.PRATTD.or.
     &     Rgvrtp(begcol).eq.PRGTLM.or.Rgvrtp(begcol).eq.PRGTLQ.or.
     &     Rgvrtp(begcol).eq.PRGTLY.or.Rgvrtp(begcol).eq.PRGTSL.or.
     &     Rgvrtp(begcol).eq.PRRTLM.or.Rgvrtp(begcol).eq.PRRTLQ.or.
     &     Rgvrtp(begcol).eq.PRRTLY.or.Rgvrtp(begcol).eq.PRRTSL.or.
     &     Rgvrtp(begcol).eq.PRATLM.or.Rgvrtp(begcol).eq.PRATLQ.or.
     &     Rgvrtp(begcol).eq.PRATLY.or.Rgvrtp(begcol).eq.PRATSL.or.
     &     Rgvrtp(begcol).eq.PRG1TD.or.Rgvrtp(begcol).eq.PRR1TD.or.
     &     Rgvrtp(begcol).eq.PRA1TD)THEN
         CALL dlrgef(begcol,Nrxy,ncol)
         IF(Lfatal)THEN
          IF(lsavlg.and.Laccss)CALL insend(Ng,'regression.ats.lkhd')
          RETURN
         END IF
        END IF
       END DO
c-----------------------------------------------------------------------
c     if Picktd, put length of month back in series.
c-----------------------------------------------------------------------
       IF(pktd)THEN
        Picktd=F
        Priadj=1
c ***  Change Nspobs to Nadj and Adj1st to 1 until END OF CHANGE
c ***  Add if block so this is only done if log transform done
c ***  JAN 2000 BCM
        IF(dpeq(Lam,0D0))THEN
         IF(Nustad.gt.0)THEN
          CALL eltfcn(DIV,Y(Frstsy),Usrtad(Frstat),Nobspf,PLEN,Trnsrs)
          CALL copy(Usrtad(Frstat),Nadj,1,Adj(1))
         ELSE
          CALL copy(Y(Frstsy),Nobspf,-1,Trnsrs)
         END IF
         IF(Nuspad.gt.0)THEN
          CALL eltfcn(DIV,Y(Frstsy),Usrpad(Frstap),Nobspf,PLEN,Trnsrs)
          IF(Nustad.gt.0)THEN
           CALL eltfcn(MULT,Adj(1),Usrpad(Frstap),Nadj,PLEN,Adj(1))
          ELSE
           CALL copy(Usrpad(Frstap),Nadj,1,Adj(1))
          END IF
         ELSE
          CALL setdp(1D0,PLEN,Adj)
         END IF
c ***  END OF CHANGE (BCM, JAN 1997)
         IF(Lmvaft.or.Ln0aft)THEN
          CALL trnfcn(trnsrs,Nspobs,Fcntyp,Lam,trnsrs)
         ELSE
          CALL trnfcn(trnsrs,Nobspf,Fcntyp,Lam,trnsrs)
         END IF
        END IF
       END IF
      END IF
c-----------------------------------------------------------------------
      IF(Lfatal)THEN
       IF(lsavlg.and.Laccss)CALL insend(Ng,'regression.ats.lkhd')
       RETURN
      END IF
c-----------------------------------------------------------------------
c     Set up the regression matrix and estimate model 2
c-----------------------------------------------------------------------
      CALL regvar(Trnsrs,Nobspf,Fctdrp,Nfcst,0,Userx,Bgusrx,Nrusrx,
     &            Priadj,Reglom,Nrxy,Begxy,Frstry,T,Elong)
      IF(.not.Lfatal)CALL rgarma(T,Mxiter,Mxnlit,F,A,Na,Nefobs,argok)
      IF((.not.Lfatal).and.(Lautom.or.Lautox).and.(.not.argok))Lester=T
c      IF(.not.Lfatal)CALL rgarma(T,Mxiter,Mxnlit,T,A,Na,Nefobs,argok)
      IF(Lfatal)THEN
       IF(lsavlg.and.Laccss)CALL insend(Ng,'regression.ats.lkhd')
       RETURN
      END IF
c-----------------------------------------------------------------------
c     If an estimation error is found, discontinue the routine.
c-----------------------------------------------------------------------
      IF(Armaer.eq.PMXIER.or.Armaer.eq.PSNGER.or.Armaer.eq.PISNER.or.
     &   Armaer.eq.PNIFER.or.Armaer.eq.PNIMER.or.Armaer.eq.PCNTER.or.
     &   Armaer.lt.0.or.((Lautom.or.Lautox).and..not.argok))THEN
       Lester=T
       IF(lsavlg.and.Laccss)CALL insend(Ng,'regression.ats.lkhd')
       RETURN
      END IF
c-----------------------------------------------------------------------
c     Compute and print out the likelihood statistics and AICC for the
c     model with TD
c-----------------------------------------------------------------------
      IF(Tdmdl1.eq.0)THEN
       IF(lprt)THEN
        IF(Laccss)CALL insacd(Mt1,'regression.ats.hdr',T)
        WRITE(Mt1,1020)tdstr(1:ntdchr)
        IF(Laccss)CALL insacd(Mt1,'regression.ats.hdr',F)
       END IF
       CALL prlkhd(Y(Frstsy),Adj(1),Adjmod,Fcntyp,Lam,0,Ptrstp,pptrfm)
       IF(Lfatal)RETURN
       aictd=Aicc
       IF(lsavlg)THEN
        WRITE(Ng,fmtsvl)'AICC('//tdstr(1:ntdchr)//')',':',Aicc
        IF(Laccss)CALL insacd(Ng,'regression.ats.lkhd',F)
       END IF
       IF(Lsumm.gt.0)WRITE(Nform,1013)'td',Aicc
      ELSE
       IF(lprt)THEN
        IF(Laccss)CALL insacd(Mt1,'regression.ats.hdr',T)
        WRITE(Mt1,1010)tdstr(1:ntdchr)
        IF(Laccss)CALL insacd(Mt1,'regression.ats.hdr',F)
       END IF
       CALL prlkhd(Y(Frstsy),Adj(1),Adjmod,Fcntyp,Lam,0,Ptrstp,pptrfm)
       IF(Lfatal)RETURN
       aicntd=Aicc
       IF(lsavlg)THEN
        WRITE(Ng,fmtsvl)'AICC(no td)',':',Aicc
        IF(Laccss)CALL insacd(Ng,'regression.ats.lkhd',F)
       END IF
       IF(Lsumm.gt.0)WRITE(Nform,1013)'notd',Aicc
      END IF
      aic2=Aicc
      IF(.not.lprt)Lhiddn=lhide
c-----------------------------------------------------------------------
      IF(lprt)THEN
       IF(Laccss)CALL insacd(Mt1,'regression.ats.lkf',T)
       IF((aictd+Rgaicd).lt.aicntd)THEN
        WRITE(Mt1,1030)Rgaicd,'with',tdstr(1:ntdchr)
       ELSE
        WRITE(Mt1,1030)Rgaicd,'without',tdstr(1:ntdchr)
       END IF
       IF(Laccss)CALL insacd(Mt1,'regression.ats.lkf',F)
      END IF
c-----------------------------------------------------------------------
c     No td in first model
c-----------------------------------------------------------------------
      IF(Tdmdl1.eq.0)THEN
c-----------------------------------------------------------------------
c     if the first model is better, restore original series and
c     reset LOM variables.
c-----------------------------------------------------------------------
       IF(aic2+Rgaicd.ge.aic1)THEN
        CALL copy(a2,PLEN,1,Adj)
        Kfmt=kf2
        Picktd=F
        Iregfx=irgfx
        IF(ilom.le.1)THEN
         Priadj=ilom
         CALL copy(tsrs,PLEN,1,Trnsrs)
        END IF
c-----------------------------------------------------------------------
c     Restore initial values to model variables
c-----------------------------------------------------------------------
        CALL restor(T,F,F)
        CALL regvar(Trnsrs,Nobspf,Fctdrp,Nfcst,0,Userx,Bgusrx,Nrusrx,
     &              Priadj,Reglom,Nrxy,Begxy,Frstry,T,Elong)
        IF((.not.Lfatal).and.Iregfx.ge.2)THEN
         CALL rmfix(trnsrs,Nbcst,Nrxy,1)
         IF(.not.Lfatal)
     &    CALL regvar(trnsrs,Nobspf,Fctdrp,Nfcst,0,Userx,Bgusrx,Nrusrx,
     &                Priadj,Reglom,Nrxy,Begxy,frstry,T,Elong)
        END IF
        IF(Lfatal)RETURN
c-----------------------------------------------------------------------
c     Set up the regression matrix and re-estimate model 1
c-----------------------------------------------------------------------
        CALL regvar(Trnsrs,Nobspf,Fctdrp,Nfcst,0,Userx,Bgusrx,Nrusrx,
     &              Priadj,Reglom,Nrxy,Begxy,Frstry,T,Elong)
        IF(.not.Lfatal)CALL rgarma(T,Mxiter,Mxnlit,Lprtit,A,Na,Nefobs,
     &                             argok)
        IF((.not.Lfatal).and.(Lautom.or.Lautox).and.(.not.argok))
     &     CALL abend()
        IF(Lfatal)RETURN
c-----------------------------------------------------------------------
c     set tdmdl1 to indicate model was not changed
c-----------------------------------------------------------------------
        Tdmdl1=0
       ELSE
c-----------------------------------------------------------------------
c     If 2nd model better, set up variables used in X-11 for prior
c     adjustment (if this model has td), then exit to print out model 2
c-----------------------------------------------------------------------
        CALL copy(Adj,Nadj,-1,Sprior(Setpri))
        IF(Kfmt.eq.0)Kfmt=1
        IF(Nuspad.eq.0.or.Npser.eq.0)THEN
         Prmser(1:3)='LPY'
         Npser=3
        END IF
        Tdmdl1=2
       END IF
      ELSE
       IF((aic1+Rgaicd).lt.aic2)THEN
c-----------------------------------------------------------------------
c     If first model better than second and first model had td,
c     restore adjustment variables
c-----------------------------------------------------------------------
        CALL copy(a2,PLEN,1,Adj)
        IF(pktd)THEN
         Picktd=pktd
         Priadj=ilom
c-----------------------------------------------------------------------
c     Redo lom adjustment and transformation.
c-----------------------------------------------------------------------
         IF(.not.(Fcntyp.eq.4.OR.dpeq(Lam,1D0)))THEN
          CALL eltfcn(DIV,Y(Frstsy),lomeff(Adj1st),Nobspf,PLEN,Trnsrs)
          IF(Lmvaft.or.Ln0aft)THEN
           CALL trnfcn(trnsrs,Nspobs,Fcntyp,Lam,trnsrs)
          ELSE
           CALL trnfcn(trnsrs,Nobspf,Fcntyp,Lam,trnsrs)
          END IF
          IF(Lfatal)RETURN
         END IF
        END IF
c-----------------------------------------------------------------------
c     Restore initial values to model variables
c-----------------------------------------------------------------------
        CALL restor(T,F,F)
        CALL regvar(Trnsrs,Nobspf,Fctdrp,Nfcst,0,Userx,Bgusrx,Nrusrx,
     &              Priadj,Reglom,Nrxy,Begxy,Frstry,T,Elong)
        IF((.not.Lfatal).and.Iregfx.ge.2)THEN
         CALL rmfix(trnsrs,Nbcst,Nrxy,1)
         IF(.not.Lfatal)
     &    CALL regvar(trnsrs,Nobspf,Fctdrp,Nfcst,0,Userx,Bgusrx,Nrusrx,
     &                Priadj,Reglom,Nrxy,Begxy,frstry,T,Elong)
        END IF
        IF(Lfatal)RETURN
c-----------------------------------------------------------------------
c     Set up the regression matrix and re-estimate model 1
c-----------------------------------------------------------------------
        CALL regvar(Trnsrs,Nobspf,Fctdrp,Nfcst,0,Userx,Bgusrx,Nrusrx,
     &              Priadj,Reglom,Nrxy,Begxy,Frstry,T,Elong)
        IF(.not.Lfatal)CALL rgarma(T,Mxiter,Mxnlit,Lprtit,A,Na,Nefobs,
     &                             argok)
        IF((.not.Lfatal).and.(Lautom.or.Lautox).and.(.not.argok))
     &     CALL abend()
        IF(Lfatal)RETURN
c-----------------------------------------------------------------------
c     set tdmdl1 to indicate model was not changed
c-----------------------------------------------------------------------
        Tdmdl1=0
       ELSE
c-----------------------------------------------------------------------
c     set tdmdl1 to indicate model was changed
c-----------------------------------------------------------------------
        Tdmdl1=1
        IF(pktd)THEN
         IF(Nustad.eq.0.and.Nuspad.eq.0)Kfmt=0
         CALL copy(Adj,Nadj,-1,Sprior(Setpri))
        END IF
       END IF
      END IF
      IF(.not.Lpradj.and.Kfmt.eq.1)Lpradj=.true.
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      RETURN
 1010 FORMAT(//,' Likelihood statistics for model without ',a)
 1011 FORMAT('(1x,a,t',i2,',a,1x,f15.4)')
c 1012 FORMAT('aictest.td.reg: ',a)
 1013 FORMAT('aictest.td.aicc.',a,': ',e29.15)
 1020 FORMAT(//,' Likelihood statistics for model with ',a)
 1030 FORMAT(//,'   *****   AICC (with aicdiff=',F5.2,
     &          ') prefers model ',a,' ',a,'   *****')
c-----------------------------------------------------------------------
      END
