C     Last change:  BCM  30 Jul 2008 4:05 pm
      SUBROUTINE usraic(Trnsrs,A,Nefobs,Na,Frstry,Lester,Lprtit,Ptrstp,
     &                  Ptrfm,Ptrsvl,Lsumm,Lhiddn)
      IMPLICIT NONE
c-----------------------------------------------------------------------
c     Estimate two regARIMA models, one with user-defined regressors and
c     one without.  This routine chooses the model with the lowest value
c     of AICC and prints out the resulting model.
c     Correct number of arguments (BCM May 2007)
c-----------------------------------------------------------------------
      LOGICAL F,T
      PARAMETER(F=.false.,T=.true.)
c-----------------------------------------------------------------------
      INCLUDE 'srslen.prm'
      INCLUDE 'model.prm'
      INCLUDE 'model.cmn'
      INCLUDE 'mdldat.cmn'
      INCLUDE 'arima.cmn'
      INCLUDE 'lkhd.cmn'
      INCLUDE 'extend.cmn'
      INCLUDE 'units.cmn'
      INCLUDE 'adj.cmn'
      INCLUDE 'prior.prm'
      INCLUDE 'prior.cmn'
      INCLUDE 'error.cmn'
      INCLUDE 'usrreg.cmn'
      INCLUDE 'title.cmn'
      INCLUDE 'tbllog.prm'
      INCLUDE 'tbllog.cmn'
      INCLUDE 'svllog.prm'
      INCLUDE 'svllog.cmn'
c-----------------------------------------------------------------------
      INTEGER PA
      PARAMETER(PA=PLEN+2*PORDER)
c-----------------------------------------------------------------------
      CHARACTER effttl*(PCOLCR),ubkttl*(PCOLCR*PUREG)
      LOGICAL lprt,Lprtit,Lester,argok,lhide,lsavlg,ubkfix,Lhiddn
      DOUBLE PRECISION A,aicnou,aicusr,Trnsrs,ubkx,ubkb
      INTEGER Frstry,i,Na,Nefobs,nchr,iuser,nubk,ubktyp,ubkptr,begcol,
     &        endcol,igrp,Lsumm,Ptrstp,Ptrfm,Ptrsvl,pptrfm
      DIMENSION A(PA),Trnsrs(PLEN),ubktyp(PUREG),ubkptr(0:PUREG),
     &          ubkx(PUSERX),ubkfix(PUREG),ubkb(PUREG)
c-----------------------------------------------------------------------
      INTEGER strinx
      EXTERNAL strinx
c-----------------------------------------------------------------------
      IF(Ptrstp.eq.0)THEN
       lprt=F
      ELSE
       lprt=Prttab(Ptrstp)
      END IF
      pptrfm=Ptrfm
      IF(Ptrfm.eq.0)pptrfm=0
      IF(Ptrsvl.eq.0)THEN
       lsavlg=F
      ELSE
       lsavlg=Svltab(Ptrsvl)
      END IF 
c-----------------------------------------------------------------------
c     Initialize variables
c-----------------------------------------------------------------------
      IF(.not.lprt)THEN
       lhide=Lhiddn
       Lhiddn=T
      END IF
c-----------------------------------------------------------------------
c     Estimate model with user-defined regressors
c-----------------------------------------------------------------------
      CALL regvar(Trnsrs,Nobspf,Fctdrp,Nfcst,0,Userx,Bgusrx,Nrusrx,
     &            Priadj,Reglom,Nrxy,Begxy,Frstry,T,Elong)
      IF(Lfatal)RETURN
      argok=Lautom.or.Lautox
      CALL rgarma(T,Mxiter,Mxnlit,F,A,Na,Nefobs,argok)
      IF((.not.Lfatal).and.(Lautom.or.Lautox).and.(.not.argok))
     &   CALL abend()
      IF(Lfatal)RETURN
c-----------------------------------------------------------------------
c     If an estimation error is found, discontinue the routine.
c-----------------------------------------------------------------------
      IF(Armaer.eq.PMXIER.or.Armaer.eq.PSNGER.or.Armaer.eq.PISNER.or.
     &   Armaer.eq.PNIFER.or.Armaer.eq.PNIMER.or.Armaer.eq.PCNTER.or.
     &   Armaer.lt.0.or.((Lautom.or.Lautox).and..not.argok))THEN
       Lester=T
       RETURN
c-----------------------------------------------------------------------
c     If only a warning message would be printed out, reset the error
c     indicator variable to zero.
c-----------------------------------------------------------------------
      ELSE IF(Armaer.ne.0)THEN
       Armaer=0
      END IF
c-----------------------------------------------------------------------
c     Compute the likelihood statistics and AICC for the model
c-----------------------------------------------------------------------
      IF(lprt)THEN
       IF(Laccss)CALL insacd(Mt1,'regression.ats.hdr',T)
       WRITE(Mt1,1010)
       IF(Laccss)CALL insacd(Mt1,'regression.ats.hdr',F)
      END IF
 1010 FORMAT(//,' Likelihood statistics for model with user-defined',
     &          ' regressors')
      CALL prlkhd(Y(Frstsy),Adj(Adj1st),Adjmod,Fcntyp,Lam,0,Ptrstp,0)
      IF(Lfatal)RETURN
      aicusr=Aicc
      IF(lsavlg)THEN
       IF(Laccss)CALL insacd(Ng,'regression.ats.lkhd',T)
       WRITE(Ng,1011)Aicc
      END IF
 1011 FORMAT(' AICC(userreg)    : ',f15.4)
      IF(Lsumm.gt.0)WRITE(Nform,1012)'user',Aicc
c-----------------------------------------------------------------------
c     Make local backup copy of user defined regressors.
c-----------------------------------------------------------------------
      CALL copy(Userx,PUSERX,1,ubkx)
      CALL cpyint(Usrtyp,PUREG,1,ubktyp)
      CALL cpyint(Usrptr(0),PUREG+1,1,ubkptr(0))
      nubk=Ncusrx
      ubkttl=Usrttl
c-----------------------------------------------------------------------
c     remove the user defined regressors from the regression matrix.
c-----------------------------------------------------------------------
      igrp=strinx(T,Grpttl,Grpptr,1,Ngrptl,'User-defined')
      begcol=Grp(igrp-1)
      endcol=Grp(igrp)-1
      DO i=endcol,begcol,-1
       iuser=i-begcol+1
       ubkb(iuser)=B(i)
       ubkfix(iuser)=Regfx(i)
      END DO
      iuser=endcol-begcol+1
      CALL dlrgef(begcol,Nrxy,iuser)
      IF(Lfatal)THEN
       IF(lsavlg.and.Laccss)CALL insend(Ng,'regression.ats.lkhd')
       RETURN
      END IF
      Ncusrx=0
c-----------------------------------------------------------------------
c     Re-estimate model without user-defined regressors
c-----------------------------------------------------------------------
      CALL regvar(Trnsrs,Nobspf,Fctdrp,Nfcst,0,Userx,Bgusrx,Nrusrx,
     &            Priadj,Reglom,Nrxy,Begxy,Frstry,T,Elong)
      IF(.not.Lfatal)CALL rgarma(T,Mxiter,Mxnlit,F,A,Na,Nefobs,argok)
      IF((.not.Lfatal).and.(Lautom.or.Lautox).and.(.not.argok))
     &   CALL abend()
      IF(Lfatal)THEN
       IF(lsavlg.and.Laccss)CALL insend(Ng,'regression.ats.lkhd')
       RETURN
      END IF
c-----------------------------------------------------------------------
c     If an estimation error is found, discontinue the routine.
c-----------------------------------------------------------------------
      IF(Armaer.eq.PMXIER.or.Armaer.eq.PSNGER.or.Armaer.eq.PISNER.or.
     &   Armaer.eq.PNIFER.or.Armaer.eq.PNIMER.or.Armaer.eq.PCNTER.or.
     &   Armaer.lt.0.or.((Lautom.or.Lautox).and..not.argok))THEN
       Lester=T
       IF(lsavlg.and.Laccss)CALL insend(Ng,'regression.ats.lkhd')
       RETURN
c-----------------------------------------------------------------------
c     If only a warning message would be printed out, reset the error
c     indicator variable to zero.
c-----------------------------------------------------------------------
      ELSE IF(Armaer.ne.0)THEN
       Armaer=0
      END IF
c-----------------------------------------------------------------------
c     Compute the likelihood statistics and AICC for the model
c-----------------------------------------------------------------------
      IF(lprt)THEN
       IF(Laccss)CALL insacd(Mt1,'regression.ats.hdr',T)
       WRITE(Mt1,1020)
       IF(Laccss)CALL insacd(Mt1,'regression.ats.hdr',F)
      END IF
 1020 FORMAT(//,' Likelihood statistics for model without user-defined',
     &          ' regressors')
      CALL prlkhd(Y(Frstsy),Adj(Adj1st),Adjmod,Fcntyp,Lam,0,Ptrstp,
     &            pptrfm)
C      CALL prlkhd(Y(Frstsy),Adj(Adj1st),Adjmod,Fcntyp,Lam,0,Ptrstp,
C     &            pptrfm,F)
      aicnou=Aicc
      IF(Lsavlg)WRITE(Ng,1021)Aicc
 1021 FORMAT(' AICC(no userreg) : ',f15.4)
      IF(Lsumm.gt.0)WRITE(Nform,1012)'nouser',Aicc
      IF(.not.lprt)Lhiddn=lhide
c-----------------------------------------------------------------------
c     Show the regression model AICC prefers
c-----------------------------------------------------------------------
      IF((aicusr+Rgaicd).lt.aicnou)THEN
       IF(lprt)THEN
        IF(Laccss)CALL insacd(Mt1,'regression.ats.lkf',T)
        WRITE(Mt1,1030)Rgaicd,'with'
        IF(Laccss)CALL insacd(Mt1,'regression.ats.lkf',F)
       END IF
c-----------------------------------------------------------------------
c     Add user-defined regressors back to model
c-----------------------------------------------------------------------
       CALL copy(ubkx,PUSERX,1,Userx)
       CALL cpyint(ubktyp,PUREG,1,Usrtyp)
       CALL cpyint(ubkptr(0),PUREG+1,1,Usrptr(0))
       Ncusrx=nubk
       Usrttl=ubkttl
c-----------------------------------------------------------------------
c     Restore user-defined regressors to the regression matrix
c-----------------------------------------------------------------------
       DO i=1,Ncusrx
        CALL getstr(Usrttl,Usrptr,Ncusrx,i,effttl,nchr)
        IF(.not.Lfatal)
     &    CALL adrgef(ubkb(i),effttl(1:nchr),'User-defined',PRGTUD,
     &                ubkfix(i),F)
       END DO
c-----------------------------------------------------------------------
c     Estimate model
c-----------------------------------------------------------------------
       CALL regvar(Trnsrs,Nobspf,Fctdrp,Nfcst,0,Userx,Bgusrx,Nrusrx,
     &             Priadj,Reglom,Nrxy,Begxy,Frstry,T,Elong)
       IF(.not.Lfatal)CALL rgarma(T,Mxiter,Mxnlit,Lprtit,A,Na,Nefobs,
     &                            argok)
       IF((.not.Lfatal).and.(Lautom.or.Lautox).and.(.not.argok))Lester=T
      ELSE
       IF(lprt)THEN
        IF(Laccss)CALL insacd(Mt1,'regression.ats.lkf',T)
        WRITE(Mt1,1030)Rgaicd,'without'
        IF(Laccss)CALL insacd(Mt1,'regression.ats.lkf',F)
       END IF
      END IF
c-----------------------------------------------------------------------
      IF(lsavlg.and.Laccss)CALL insacd(Ng,'regression.ats.lkhd',F)
c-----------------------------------------------------------------------
 1012 FORMAT('aictest.u.aicc.',a,': ',e29.15)
 1030 FORMAT(//,'   *****   AICC (with aicdiff=',F5.2,
     &          ') prefers model ',a,' user-defined regressor   *****')
      RETURN
      END
