C     Last change:  BCM  11 Mar 2009 9:14 am
      SUBROUTINE x11ari(Lmodel,Lx11,Lcomp,Issap,Irev,Ixreg,Lsumm,Lgraf)
      IMPLICIT NONE
c-----------------------------------------------------------------------
C --- THIS SUBROUTINE PARTITIONS X-11 AND ARIMA ROUTINES TO
C --- IMPROVE THE OVERLAY STRUCTURE.
c-----------------------------------------------------------------------
      INCLUDE 'stdio.i'
      INCLUDE 'srslen.prm'
      INCLUDE 'model.prm'
      INCLUDE 'arima.cmn'
      INCLUDE 'mdldat.cmn'
      INCLUDE 'agr.cmn'
      INCLUDE 'lzero.cmn'
      INCLUDE 'title.cmn'
      INCLUDE 'units.cmn'
      INCLUDE 'extend.cmn'
      INCLUDE 'error.cmn'
      INCLUDE 'x11adj.cmn'
      INCLUDE 'x11log.cmn'
      INCLUDE 'x11msc.cmn'
      INCLUDE 'svllog.prm'
      INCLUDE 'svllog.cmn'
      INCLUDE 'mdltbl.i'
      INCLUDE 'spcsvl.i'
c      INCLUDE 'tbllog.prm'
c      INCLUDE 'tbllog.cmn'
      INCLUDE 'priusr.cmn'
      INCLUDE 'rho.cmn'
      INCLUDE 'x11opt.cmn'
c-----------------------------------------------------------------------
      LOGICAL F,T
      PARAMETER(F=.false.,T=.true.)
c-----------------------------------------------------------------------
      LOGICAL Lmodel,Lx11,havmdl,Lrvsa,Lrvsf,Lrvch,Lrvaic,Lrvfct,Lcomp,
     &        Lrvtrn,Lrfrsh,Revfix,Revfxx,extok,Lrvtch,Rvtran,Cnctar,
     &        Lgraf,Rvxotl
      INTEGER nf2,nspdir,ntpdir,Issap,Irev,Ixreg,Lsumm,ixrbak,kswbak
      REAL ticks
c-----------------------------------------------------------------------
      COMMON /revlog/ Lrvsa,Lrvsf,Lrvch,Lrvtrn,Lrvtch,Lrvaic,Lrvfct,
     &                Lrfrsh,Revfix,Revfxx,Rvtran,Cnctar,Rvxotl
c-----------------------------------------------------------------------
      Svpeak=(Iagr.lt.3.and.Svltab(LSLSPC)).or.(Iagr.eq.3.and.
     &       (Svltab(LSLCSP).or.Svltab(LSLDSP).or.Svltab(LSLISP))).OR.
     &       (Lsumm.gt.0)
      nspdir=0
      ntpdir=0
      havmdl=F
      IF((.not.(Lautom.or.Lautox)).and.Lmodel)havmdl=T
c-----------------------------------------------------------------------
c     perform automatic transformation test 
c     (BCM, July 1997, moved here Nov. 1999)
c-----------------------------------------------------------------------
      IF(Fcntyp.eq.0)THEN
       Nspobs=Nofpob-Nfcst
       CALL trnaic(Lx11,Lmodel,LTRAIC,LESTFM)
       IF(Lfatal)RETURN
      END IF
c-----------------------------------------------------------------------
C --- PRIOR-SIMULTANEOUS TRADING DAY AND HOLIDAY ADJUSTMENTS.
c-----------------------------------------------------------------------
      IF(Lx11)THEN
       Axhol=F
       IF(Issap.lt.2.or.Irev.lt.4)Kh2=Khol
       IF(Ixreg.eq.2.or.Khol.eq.1)THEN
        CALL xrgdrv(Lmodel,Lx11,Kh2,Mt1,Lgraf)
        IF(Lfatal)RETURN
       END IF
      END IF
c-----------------------------------------------------------------------
C --- PRIOR ADJUSTMENTS.
c-----------------------------------------------------------------------
      CALL x11pt1(Lmodel,Lgraf,Lgraf)
      IF(Lfatal)RETURN
c-----------------------------------------------------------------------
c --- REG-ARIMA MODELLING.
c-----------------------------------------------------------------------
      IF(Lmodel)THEN
       IF(Same)THEN
        CALL writln('The program will not estimate a regARIMA model for 
     &a constant series.',STDERR,Mt2,T)
        IF(Adjtd.eq.1)Adjtd=0
        IF(Adjhol.eq.1)Adjhol=0
        IF(Adjao.eq.1)Adjao=0
        IF(Adjls.eq.1)Adjls=0
        IF(Adjtc.eq.1)Adjtc=0
        IF(Adjusr.eq.1)Adjusr=0
        IF(Adjsea.eq.1)Adjsea=0
        IF((.NOT.(Axrghl.or.Axruhl.or.Khol.ge.1)).and.Finhol)Finhol=F
        IF(Finao)Finao=F
        IF(Finls)Finls=F
        IF(Fintc)Fintc=F
        IF(Finusr)Finusr=F
       ELSE
        extok=T
        IF(Lsumm.gt.0.and.(Issap.lt.2.and.Irev.lt.4))THEN
         CALL cpu_time(ticks)
         WRITE(Nform,9000) 'barima:',ticks
        END IF
        CALL arima(havmdl,extok,Lx11,Lgraf)
        IF(Lsumm.gt.0.and.(Issap.lt.2.and.Irev.lt.4))THEN
         IF(Lfatal)RETURN
         CALL cpu_time(ticks)
         WRITE(Nform,9000) 'earima:',ticks
        END IF
       END IF
       IF(Lfatal)RETURN
       IF((Same.or.(.not.havmdl).or.(.not.extok)).and.Lmodel)THEN
        nf2=Nfcst
        Nfcst=0
        Nbcst=0
        IF(Nfdrp.gt.0)Nfdrp=0
        CALL setxpt(nf2,Lx11,Fctdrp)
        IF(Nuspad.gt.0)THEN
         CALL dfdate(Begspn,Bgupad,Ny,Frstap)
         Frstap=Frstap+1
        END IF
        IF(Nustad.gt.0)THEN
         CALL dfdate(Begspn,Bgutad,Ny,Frstat)
         Frstat=Frstat+1
        END IF
       END IF
       IF(.not.havmdl.and.Lmodel)Lmodel=F
c       IF(.NOT.(Ny.eq.36.or.Ny.eq.24.or.Ny.eq.12.or.Ny.eq.4))RETURN
       IF(.NOT.(Ny.eq.12.or.Ny.eq.4))RETURN
      END IF
c-----------------------------------------------------------------------
c     If this is a revisions run and no seasonal adjustment diagnostics
c     are being analyzed, exit routine.
c-----------------------------------------------------------------------
      IF((.not.(Lrvsa.or.Lrvsf.or.Lrvch.or.Lrvtrn).or.(.not.Lx11)).and.
     &   Irev.eq.4)RETURN
c-----------------------------------------------------------------------
c --- X-11 Seasonal Adjustment
c-----------------------------------------------------------------------
C --- X-11 PARTS B1 TO D7.
c-----------------------------------------------------------------------
      IF(Lsumm.gt.0.and.Lx11.and.(Issap.lt.2.and.Irev.lt.4))THEN
       CALL cpu_time(ticks)
       WRITE(Nform,9000) 'bx11:',ticks
      END IF
      IF((.not.Lcmpaq).or.Lx11)CALL x11pt2(Lmodel,Lx11,Lgraf,Lgraf)
      IF(Lfatal)RETURN
c-----------------------------------------------------------------------
C --- X-11 PARTS D8 TO D16.
c-----------------------------------------------------------------------
      IF(Lx11)THEN
       CALL x11pt3(Lgraf)
       IF(Lfatal.or.Issap.eq.2.or.Irev.eq.4)RETURN
c-----------------------------------------------------------------------
C --- X-11 PARTS E1 TO F4.
c-----------------------------------------------------------------------
       CALL x11pt4(Lgraf)
       IF(Lfatal)RETURN
       IF(Lsumm.gt.0)THEN
        CALL cpu_time(ticks)
        WRITE(Nform,9000) 'ex11:',ticks
       END IF
      END IF
c-----------------------------------------------------------------------
c     Produce spectral plots
c-----------------------------------------------------------------------
      IF(.not.Same)THEN
       CALL spcdrv(Muladd,Iagr,Kswv,Ny,Lx11,Kfulsm,Lgraf,Lmodel)
       IF(Lfatal)RETURN
       IF(Nspeak.gt.0)nspdir=Nspeak-1
       IF(Ntpeak.gt.0)ntpdir=Ntpeak-1
      END IF
      IF((.not.Lcomp).and.Iagr.gt.0.and.Lx11)THEN
c-----------------------------------------------------------------------
C --- INDIRECT AGGREGATE SEASONAL ADJUSTMENT.
c-----------------------------------------------------------------------
       IF(Iagr.eq.3)THEN
        ixrbak=Ixreg
        kswbak=Kswv
        Ixreg=0
        Kswv=0
        CALL agr3(Lgraf,Begspn)
        IF(.not.Lfatal)CALL x11pt4(Lgraf)
        IF(.not.Lfatal)
     &     CALL spcdrv(Muladd,Iagr,Kswv,Ny,Lx11,Kfulsm,Lgraf,Lmodel)
        IF(Lfatal)RETURN
        Ixreg=ixrbak
        Kswv= kswbak
       END IF
       IF(Iag.ge.0.or.Iagr.eq.4)CALL agr2(Issap,Irev,Svpeak,Begspn)
      END IF
c-----------------------------------------------------------------------
      IF(Svpeak)THEN
       CALL savpk(Iagr,Lsumm,nspdir,ntpdir)
       IF(Issap.eq.0.and.Irev.eq.0.and.Iagr.gt.3)Iagr=0
      END IF
c-----------------------------------------------------------------------
 9000 FORMAT(a,e15.8)
      RETURN
      END

