C     Last change:  BCM  29 Oct 2008 4:00 pm
c-----------------------------------------------------------------------
c     Table pointer variables used for prttbl and savtbl are of the form
c L<spec><type> where the spec codes are 
c-----------------------------------------------------------------------
c regadjust      MAD or MA
c x11            X11 or XE
c-----------------------------------------------------------------------
c and the types are
c-----------------------------------------------------------------------
c ao outlier factors                                AO 
c level change factors                              LC 
c td factors (regression)                           TD 
c holiday factors (regression)                      HOL
c user defined regression factors                   USR
c regarima outlier adj original series              A11
c adjusted original                                 B1 
c modified original                                 MO 
c final modified original                           E1 
c mcd moving avgerage                               F1 
c initial trend                                     ITN 
c modified seasonally adjusted                      E2 
c initial unmodified si b                           B3 
c final modified irregular                          E3 
c initial replacement si b                          B4 
c initial modified si                               IMS 
c initial seasonal                                  ISF 
c change in original                                E5 
c initial seasonal adjusted                         ISA
c change in seasonal adjusted                       E6 
c change in adjusted seasonal adjusted              E6A 
c change in rounded seasonal adjusted               E6R 
c preliminary trend                                 PTN
c henderson trend adjusted for extremes             E7
c unmodified si b                                   B8 
c final unmodified si                               D8 
c replacement si b                                  B9 
c modified si c                                     C9 
c final replacement si                              D9 
c preliminary seasonal                              PSF
c final seasonal                                    D10
c final seasonal difference                         FSD
c preliminary seasonal adjusted                     PSA
c final seasonal adjusted                           D11
c robust seasonal adjusted                          E11
c final trend                                       D12
c bias correction factors                           BCF
c preliminary irregular                             PI
c final irregular                                   D13
c irregular wts                                     IW
c extreme values                                    EV
c holiday factors                                   H1 
c prior td                                          A4 
c seasonal adjusted, yr totals adj                  SAA
c rounded seasonal adjusted                         RND
c irregular excluded from ts                        IRX
c td factors (X11)                                  TDF
c combined adjustment factors                       D16      
c combined adjustment differences                   FAD      
c combined td factos                                CTD
c td adjusted original                              TDO
c ftest, b1                                         B1F
c ftest, hol                                        H1F
c x11 diagnostic summary                            F2 
c q statistics                                      F3 
c yearly totals                                     E4 
c ftest, d8                                         D8F
c moving seasonality ratio                          D9A
c residual seasonality f-test                       RSF
c automatic s.f. selection                          ASF
c td by type of day                                 TDY
c spectrum, diff seas. adj. srs                     S1
c spectrum, modified irregular                      S2
c modified original series plot                     B1P
c series vrs. sa series plot                        E0
c ratios of series plot                             RA1
c ratios of sa series plot                          RA2
c final seasonal factors plot                       SFP
c final seasonally adj. plot                        SAP
c final trend component plot                        TRP
c final irregular component plot                    IRP
c-----------------------------------------------------------------------
      INTEGER LX11MO,LX11E1,LX11F1,LXEITN,LX11E2,LX11B3,LX11E3,LX11B4,
     &        LXEIMS,LXEISF,LX11E5,LXEE5P,LXEISA,LX11E6,LXEE6P,LXEPTN,
     &        LX11E7,LXEE7P,LX11B8,LX11D8,LXED8B,LX11E8,LXEE8P,LX11B9,
     &        LX11C9,LX11D9,LXEB10,LXED10,LXEPSF,LXEFSD,LXEARS,LXESNS,
     &        LXEPSA,LXED11,LXESAC,LXEE11,LXED12,LXETAL,LXEBCF,LXETAC,
     &        LX11PI,LXED13,LXEPIR,LXEIAO,LX11IW,LX11EV,LX11H1,LXECHL,
     &        LXED16,LXEPAF,LXEFAD,LXED18,LXEE18,LXEEEB,LXETDO,LXEB1F,
     &        LX11F2,LX11F3,LX11E4,LXED8F,LXED9A,LXERSF,LXEASF,LXETDY,
     &        LX11S1,LX11S2,LX11E0,LXERA1,LXERA2,LXESFP,LXESAP,LXETRP,
     &        LXEIRP,LXESAF,LXETRF
      PARAMETER(
     &          LX11MO=87,LX11E1=89,LX11F1=90,LXEITN=91,LX11E2=94,
     &          LX11B3=95,LX11E3=96,LX11B4=97,LXEIMS=98,LXEISF=100,
     &          LX11E5=103,LXEE5P=104,LXEISA=105,LX11E6=108,LXEE6P=109,
     &          LXEPTN=110,LX11E7=113,LXEE7P=114,LX11B8=115,LX11D8=116,
     &          LXED8B=117,LX11E8=118,LXEE8P=119,LX11B9=120,LX11C9=121,
     &          LX11D9=122,LXEB10=123,LXED10=125,LXEPSF=126,LXEFSD=127,
     &          LXEARS=128,LXESNS=129,LXEPSA=130,LXED11=132,LXESAC=133,
     &          LXEE11=134,LXED12=135,LXETAL=136,LXEBCF=137,LXETAC=138,
     &          LX11PI=139,LXED13=141,LXEPIR=142,LXEIAO=143,LX11IW=144,
     &          LX11EV=146,LX11H1=148,LXECHL=149,LXED16=150,LXEPAF=151,
     &          LXEFAD=152,LXED18=153,LXEE18=154,LXEEEB=155,LXETDO=156,
     &          LXEB1F=158,LX11F2=159,LX11F3=160,LX11E4=161,LXED8F=162,
     &          LXED9A=163,LXERSF=164,LXEASF=165,LXETDY=166,LX11S1=167,
     &          LX11S2=168,LX11E0=169,LXERA1=170,LXERA2=171,LXESFP=172,
     &          LXESAP=173,LXETRP=174,LXEIRP=175,LXESAF=176,LXETRF=177)
